]> asedeno.scripts.mit.edu Git - git.git/blob - t/lib-git-svn.sh
git-svn: fix cloning of HTTP URLs with '+' in their path
[git.git] / t / lib-git-svn.sh
1 . ./test-lib.sh
2
3 if test -n "$NO_SVN_TESTS"
4 then
5         test_expect_success 'skipping git-svn tests, NO_SVN_TESTS defined' :
6         test_done
7         exit
8 fi
9
10 GIT_DIR=$PWD/.git
11 GIT_SVN_DIR=$GIT_DIR/svn/git-svn
12 SVN_TREE=$GIT_SVN_DIR/svn-tree
13
14 svn >/dev/null 2>&1
15 if test $? -ne 1
16 then
17     test_expect_success 'skipping git-svn tests, svn not found' :
18     test_done
19     exit
20 fi
21
22 svnrepo=$PWD/svnrepo
23
24 perl -w -e "
25 use SVN::Core;
26 use SVN::Repos;
27 \$SVN::Core::VERSION gt '1.1.0' or exit(42);
28 system(qw/svnadmin create --fs-type fsfs/, '$svnrepo') == 0 or exit(41);
29 " >&3 2>&4
30 x=$?
31 if test $x -ne 0
32 then
33         if test $x -eq 42; then
34                 err='Perl SVN libraries must be >= 1.1.0'
35         elif test $x -eq 41; then
36                 err='svnadmin failed to create fsfs repository'
37         else
38                 err='Perl SVN libraries not found or unusable, skipping test'
39         fi
40         test_expect_success "$err" :
41         test_done
42         exit
43 fi
44
45 rawsvnrepo="$svnrepo"
46 svnrepo="file://$svnrepo"
47
48 poke() {
49         test-chmtime +1 "$1"
50 }
51
52 for d in \
53         "$SVN_HTTPD_PATH" \
54         /usr/sbin/apache2 \
55         /usr/sbin/httpd \
56 ; do
57         if test -f "$d"
58         then
59                 SVN_HTTPD_PATH="$d"
60                 break
61         fi
62 done
63 for d in \
64         "$SVN_HTTPD_MODULE_PATH" \
65         /usr/lib/apache2/modules \
66         /usr/libexec/apache2 \
67 ; do
68         if test -d "$d"
69         then
70                 SVN_HTTPD_MODULE_PATH="$d"
71                 break
72         fi
73 done
74
75 start_httpd () {
76         repo_base_path="$1"
77         if test -z "$SVN_HTTPD_PORT"
78         then
79                 echo >&2 'SVN_HTTPD_PORT is not defined!'
80                 return
81         fi
82         if test -z "$repo_base_path"
83         then
84                 repo_base_path=svn
85         fi
86
87         mkdir "$GIT_DIR"/logs
88
89         cat > "$GIT_DIR/httpd.conf" <<EOF
90 ServerName "git-svn test"
91 ServerRoot "$GIT_DIR"
92 DocumentRoot "$GIT_DIR"
93 PidFile "$GIT_DIR/httpd.pid"
94 LockFile logs/accept.lock
95 Listen 127.0.0.1:$SVN_HTTPD_PORT
96 LoadModule dav_module $SVN_HTTPD_MODULE_PATH/mod_dav.so
97 LoadModule dav_svn_module $SVN_HTTPD_MODULE_PATH/mod_dav_svn.so
98 <Location /$repo_base_path>
99         DAV svn
100         SVNPath $rawsvnrepo
101 </Location>
102 EOF
103         "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k start
104         svnrepo="http://127.0.0.1:$SVN_HTTPD_PORT/$repo_base_path"
105 }
106
107 stop_httpd () {
108         test -z "$SVN_HTTPD_PORT" && return
109         "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k stop
110 }
111
112 convert_to_rev_db () {
113         perl -w -- - "$@" <<\EOF
114 use strict;
115 @ARGV == 2 or die "Usage: convert_to_rev_db <input> <output>";
116 open my $wr, '+>', $ARGV[1] or die "$!: couldn't open: $ARGV[1]";
117 open my $rd, '<', $ARGV[0] or die "$!: couldn't open: $ARGV[0]";
118 my $size = (stat($rd))[7];
119 ($size % 24) == 0 or die "Inconsistent size: $size";
120 while (sysread($rd, my $buf, 24) == 24) {
121         my ($r, $c) = unpack('NH40', $buf);
122         my $offset = $r * 41;
123         seek $wr, 0, 2 or die $!;
124         my $pos = tell $wr;
125         if ($pos < $offset) {
126                 for (1 .. (($offset - $pos) / 41)) {
127                         print $wr (('0' x 40),"\n") or die $!;
128                 }
129         }
130         seek $wr, $offset, 0 or die $!;
131         print $wr $c,"\n" or die $!;
132 }
133 close $wr or die $!;
134 close $rd or die $!;
135 EOF
136 }